dofile_once("mods/scoita/files/scripts/scoreManager/scoreManagerInterface.lua")
dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")

local old_death = death

death = function()
    local entity = GetUpdatedEntityID()
    local entityName = GameTextGetTranslatedOrNot(EntityGetName(entity))
    local amount = 10;

    local healthMultiplier = tonumber(MagicNumbersGetValue("GUI_HP_MULTIPLIER"))

    local comp_damage = EntityGetFirstComponent(entity, "DamageModelComponent" )
    local max_hp = tonumber(ComponentGetValue2(comp_damage, "max_hp"))
    local health = max_hp * healthMultiplier
    local metaData = {
        relatedRule = KnownRuleNames.OnBossKill,
        eventType = KnownRuleNames.OnBossKill,
        entityName = EntityGetName(entity),
    }
    
    amount = math.floor(health)

    local scoreEvent = {
        desc = "Killed the "..entityName.." boss!!!", 
        points = POINTSFORBOSS, 
        metaData = metaData
    }

    addScoreEventForPlayer(scoreEvent)
    old_death()
end