dofile_once("data/scripts/lib/utilities.lua")
dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")
dofile_once("mods/scoita/files/scripts/scoreManager/scoreManagerInterface.lua")

function death( damage_type_bit_field, damage_message, entity_thats_responsible, drop_items )
   
    amount = 0;
    local entity = GetUpdatedEntityID()
    local healthMultiplier = tonumber(MagicNumbersGetValue("GUI_HP_MULTIPLIER"))

    local comp_damage = EntityGetFirstComponent(entity, "DamageModelComponent" )
    local max_hp = tonumber(ComponentGetValue2(comp_damage, "max_hp"))
    local health = max_hp * healthMultiplier
    
    local healthScaledForPoints = health;
    amount = math.floor(healthScaledForPoints)
    
    if(amount < ScoitaModConstants.LowestKillPoints) then
        amount = ScoitaModConstants.LowestKillPoints
    end

    if(entity_thats_responsible == getPlayerEntity()) then
        
        local metaData = {
            relatedRule = KnownRuleNames.OnBasicEnemyKill,
            eventType = KnownRuleNames.OnBasicEnemyKill,
            entityName = EntityGetName(entity),
        }

        local entityNameSanitised = string.gsub(string.sub(EntityGetName(entity),2), "animal_", "")
        local scoreEvent = {desc = "Killed a " ..GameTextGetTranslatedOrNot(EntityGetName(entity)).." ("..entityNameSanitised..")", points = amount, metaData = metaData};
        addScoreEventForPlayer(scoreEvent)
    end
    
    
end