dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")
dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/killABoss.lua")
dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/killAnEnemy.lua")
dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/killAnAmountOfEnemies.lua")
dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/playerGoldCount.lua")
dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/playerHealth.lua")
dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/getToPlace.lua")

RuleTriggerManager = {}

function RuleTriggerManager:new(o)
    local this = o or {
        triggerTypes = {
            killABoss = killABoss,
            killAnEnemy = killAnEnemy,
            killAnAmountOfEnemies = killAnAmountOfEnemies,
            playerGoldCount = playerGoldCount,
            playerHealth = playerHealth,
            getToPlace = getToPlace,
        }
    }
    setmetatable(this,self)
    self.__index = self

    function this:createNewTrigger(type, info)
        if(self.triggerTypes[type] == nil) then
            print("TRIGGER_ERROR : Type not found "..type)
        end

        local triggerDefinition = self.triggerTypes[type]
        local newTrigger = triggerDefinition:new()
        newTrigger.id = info.id
        newTrigger.config = info
        newTrigger:init()

        return newTrigger
    end

    return this;
end

ruleTriggerManager = RuleTriggerManager:new()