dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/baseTrigger.lua")
dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")

getToPlace = Trigger:new("getToPlace")

function getToPlace:new(o)
    o = o or Trigger:new(o)
    setmetatable(o, self)
    self.__index = self

    --self.eventsToListen[KnownRuleNames.???] = true
    self.shouldCheckEveryFrame = true
    return self
end

function getToPlace:createBaseState(config)
    return {
        config = config,
        description = {
            intent = "intent not set for getToPlace",
            oneLinerWithState = "oneLinerWithState not set for getToPlace",
            detail = "Header not set for getToPlace",
        },
        state = {
            isTriggered = false,
        },
    }
end

function getToPlace:updateTrigger(updateContext)
    local player = EntityGetWithTag("player_unit")[1]
    local x, y = EntityGetTransform(player)
    local ruleSpecificConfig = self.config.ruleSpecificConfig
    if(self.config.ruleSpecificConfig.check == "getWithinXY") then
        local targetPos = ruleSpecificConfig.pos
        local minDistance = ruleSpecificConfig.minDistance

        local distance = math.abs(targetPos.x - x) + math.abs(targetPos.y - y)
        updateContext.triggerState.state.isTriggered = distance <= minDistance

        self:updateStateDescription(updateContext.triggerState, self.config.ruleSpecificConfig.descriptionPrefix, distance, minDistance, updateContext.triggerState.state.isTriggered)
    end
    
end

function getToPlace:processEvent(event, state)
    local returnResult = self:triggerProcessEventResult()        
    return returnResult;
    
end

function getToPlace:updateStateDescription(state, prefix, distance, minDistance, isWithinDistance)
    if(isWithinDistance) then 
        state.description.oneLinerWithState = prefix.." Done"
    else 
        state.description.oneLinerWithState = prefix.." ("..math.floor(distance - minDistance).."m )"
    end
end