dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/baseTrigger.lua")
dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")

killABoss = Trigger:new("killABoss")

function killABoss:new(o)
    o = o or Trigger:new(o)
    setmetatable(o, self)
    self.__index = self

    self.eventsToListen[KnownRuleNames.OnBossKill] = true
    --self.shouldCheckEveryFrame = true
    return self
end

function killABoss:createBaseState(config)
    local state = {
        config = config,
        description = {
            intent = "intent not set for killABoss",
            oneLinerWithState = "oneLinerWithState not set for killABoss",
            detail = "Header not set for killABoss",
        },
        state = {
            isTriggered = false,
        },
    }

    self:updateStateDescription(state,self.config.ruleSpecificConfig.entityName, state.state.isTriggered)
    return state
end

function killABoss:updateTrigger(updateContext)
end

function killABoss:processEvent(event, state)
    local returnResult = self:triggerProcessEventResult()    

    local isMatchingBoss = event.metaData.entityName == self.config.ruleSpecificConfig.entityName;
    if(isMatchingBoss) then
        state.state.isTriggered = true
        self:updateStateDescription(state, self.config.ruleSpecificConfig.entityName, state.state.isTriggered)
    end

    return returnResult;
    
end

function killABoss:updateStateDescription(state, bossEntityName, isKilled)
    local msg = nil
    
    if(isKilled) then
        msg = "Killed "..GameTextGetTranslatedOrNot(bossEntityName)
    else
        msg = "Kill "..GameTextGetTranslatedOrNot(bossEntityName)
    end

    state.description.oneLinerWithState = msg
end