dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/baseTrigger.lua")
dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")

killAnAmountOfEnemies = Trigger:new("killAnAmountOfEnemies")

function killAnAmountOfEnemies:new(o)
    o = o or Trigger:new(o)
    setmetatable(o, self)
    self.__index = self

    self.eventsToListen[KnownRuleNames.OnBasicEnemyKill] = true
    --self.shouldCheckEveryFrame = true
    return self
end

function killAnAmountOfEnemies:createBaseState(config)
    local state = {
        config = config,
        description = {
            intent = "intent not set for killAnAmountOfEnemies",
            oneLinerWithState = "oneLinerWithState not set for killAnAmountOfEnemies",
            detail = "Header not set for killAnAmountOfEnemies",
        },
        state = {
            isTriggered = false,
            current = 0
        },
    }

    self:updateStateDescription(state,self.config.ruleSpecificConfig.entityName, state.state.current, self.config.ruleSpecificConfig.amount, state.state.isTriggered)
    return state
end

function killAnAmountOfEnemies:updateTrigger(updateContext)
end

function killAnAmountOfEnemies:processEvent(event, state)
    
    local returnResult = self:triggerProcessEventResult()    

    local shouldCountKill = nil
    if(self.config.ruleSpecificConfig.entityName ~= nil) then
        shouldCountKill = event.metaData.entityName == self.config.ruleSpecificConfig.entityName;
    else
        shouldCountKill = true
    end
    
    if(shouldCountKill) then
        state.state.current = state.state.current + 1
        
        if(state.state.current == self.config.ruleSpecificConfig.amount) then
            state.state.isTriggered = true
        end
        
        self:updateStateDescription(state, self.config.ruleSpecificConfig.entityName, state.state.current, self.config.ruleSpecificConfig.amount, state.state.isTriggered)
    end

    return returnResult;
    
end

function killAnAmountOfEnemies:updateStateDescription(state, entityName, killCount, killCountTarget,triggered)
    local msg = nil

    if(entityName ~= nil) then
        if(triggered) then
            msg = "Killed "..killCountTarget.." "..GameTextGetTranslatedOrNot(entityName)
        else
            msg = "Kill "..GameTextGetTranslatedOrNot(entityName).." ("..killCount.."/"..killCountTarget..")"
        end
    else
        if(triggered) then
            msg = "Killed "..killCountTarget.." enemies"..GameTextGetTranslatedOrNot(entityName)
        else
            msg = "Kill enemies ("..killCount.."/"..killCountTarget..")"
        end
    end

    state.description.oneLinerWithState = msg
end