dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/baseTrigger.lua")
dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")

killAnEnemy = Trigger:new("killAnEnemy")

function killAnEnemy:new(o)
    o = o or Trigger:new(o)
    setmetatable(o, self)
    self.__index = self

    self.eventsToListen[KnownRuleNames.OnBasicEnemyKill] = true
    --self.shouldCheckEveryFrame = true
    return self
end

function killAnEnemy:createBaseState(config)
    local state = {
        config = config,
        description = {
            intent = "intent not set for killAnEnemy",
            oneLinerWithState = "oneLinerWithState not set for killAnEnemy",
            detail = "Header not set for killAnEnemy",
        },
        state = {
            isTriggered = false,
        },
    }

    self:updateStateDescription(state,self.config.ruleSpecificConfig.entityName, state.state.isTriggered)
    return state
end

function killAnEnemy:updateTrigger(updateContext)
end

function killAnEnemy:processEvent(event, state)
    
    local returnResult = self:triggerProcessEventResult()    

    local isMatchingEnemy = event.metaData.entityName == self.config.ruleSpecificConfig.entityName;
    if(isMatchingEnemy) then
        state.state.isTriggered = true
        self:updateStateDescription(state, self.config.ruleSpecificConfig.entityName, state.state.isTriggered)
    end

    return returnResult;
    
end

function killAnEnemy:updateStateDescription(state, entityName, isKilled)
    local msg = nil
    
    if(isKilled) then
        msg = "Killed "..GameTextGetTranslatedOrNot(entityName)
    else
        msg = "Kill "..GameTextGetTranslatedOrNot(entityName)
    end

    state.description.oneLinerWithState = msg
end