dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/baseTrigger.lua")
dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")
dofile_once("data/scripts/lib/utilities.lua")


playerGoldCount = Trigger:new("playerGoldCount")

function playerGoldCount:new(o)
    o = o or Trigger:new(o)
    setmetatable(o, self)
    self.__index = self

    --self.eventsToListen[KnownRuleNames.???] = true
    self.shouldCheckEveryFrame = true
    return self
end

function playerGoldCount:createBaseState(config)
    return {
        config = config,
        description = {
            intent = "intent not set for playerGoldCount",
            oneLinerWithState = "oneLinerWithState not set for playerGoldCount",
            detail = "Header not set for playerGoldCount",
        },
        state = {
            isTriggered = false
        },
    }
end

function playerGoldCount:updateTrigger(updateContext)
    local playerEntity = getPlayerEntity()
    local dcomp = EntityGetFirstComponent( playerEntity, "WalletComponent" )
    if(dcomp == nil) then
        do return end
    end

    local money = ComponentGetValue2( dcomp, "money" )
    -- Player is probably dead
    if(money == nil) then
        do return end
    end
    updateContext.triggerState.state.isTriggered = money >= self.config.ruleSpecificConfig.amount
    self:updateStateDescription(updateContext, updateContext.triggerState.state.isTriggered and self.config.ruleSpecificConfig.amount or money)
end

function playerGoldCount:processEvent(event, state)
    local returnResult = self:triggerProcessEventResult()        
    return returnResult;
    
end

function playerGoldCount:updateStateDescription(updateContext, money)
    updateContext.triggerState.description.oneLinerWithState = "Gold : "..money.." of "..tostring(self.config.ruleSpecificConfig.amount)
end