dofile_once("mods/scoita/files/scripts/ruleTriggers/triggers/baseTrigger.lua")
dofile_once("mods/scoita/files/scripts/rules/knownRuleTypes.lua")

playerHealth = Trigger:new("playerHealth")

function playerHealth:new(o)
    o = o or Trigger:new(o)
    setmetatable(o, self)
    self.__index = self

    self.eventsToListen[KnownEventNames.OnPlayerDamaged] = true
    --self.shouldCheckEveryFrame = true
    return self
end

function playerHealth:createBaseState(config)
    local state = {
        config = config,
        description = {
            intent = "intent not set for playerHealth",
            oneLinerWithState = "oneLinerWithState not set for playerHealth",
            detail = "Header not set for playerHealth",
        },
        state = {
            isTriggered = true,
            isFailed = false,
            currentTotalDamage = 0
        },
    }

    self:updateStateDescription({triggerState = state}, state.state.currentTotalDamage)
    return state
end

function playerHealth:updateTrigger(updateContext)
end

function playerHealth:processEvent(event, state)

    -- Don't process if already failed (it shows the millions of damage teh superMurder function does)
    if(state.state.isFailed) then
        local returnResult = self:triggerProcessEventResult()        
        do return returnResult end
    end

    state.state.currentTotalDamage = state.state.currentTotalDamage + event.damage

    if(self.config.ruleSpecificConfig.check == "totalDamageTakenLessThan") then
        state.state.isTriggered = state.state.currentTotalDamage <= self.config.ruleSpecificConfig.amount
        state.state.isFailed = not state.state.isTriggered
    end

    self:updateStateDescription({triggerState = state}, state.state.currentTotalDamage)

    local returnResult = self:triggerProcessEventResult()        
    return returnResult;
    
end

function playerHealth:updateStateDescription(updateContext, currentDamage)
    local prefix = ""
    if(updateContext.triggerState.state.isFailed) then
        prefix = "Failed : "
    end
    updateContext.triggerState.description.oneLinerWithState = prefix.."Take < "..self.config.ruleSpecificConfig.amount.." damage (taken "..math.floor(currentDamage)..")"
end