local isUnshackleEnabled = ModIsEnabled("evaisa.unshackle")
local doesModHaveUnsafePermissions = false

function tryGetClock()
	return os.clock() ~= nil;
end

if not pcall(tryGetClock) then
	-- We don't have unsafe permissions :(
	doesModHaveUnsafePermissions = false
else
   doesModHaveUnsafePermissions = true
end

if(doesModHaveUnsafePermissions) then
	ModSettingSet("SCOITA_LOAD_VIA_UNSHACKLE", false)
	print("Loading scoita without unshackle")
	
	dofile_once("mods/scoita/scoitaInit.lua")
elseif(isUnshackleEnabled) then
	ModSettingSet("SCOITA_LOAD_VIA_UNSHACKLE", true)
	print("Loading scoita via unshackle")
else
	print("WARNING : UNSAFE MODS NOT ENABLED and unshackle isn't enabled")
end